package graphiquetest; 
import java.awt.geom.*;
import java.awt.*;
import graphique.FenetreGraphique;


class Ex1 extends FenetreGraphique 
{
  Ex1 () {}
  Ex1 (int w, int h, Color c) {
    super(w,h,c);
  }

  public void dessiner(Graphics2D g2)
  {
    int
      max = 6,       // nombre de cercles
      epais = 15;    // paisseur du trait
    float 
      cx=getLargeur()/2, // coordonnes du centre 
      cy=getHauteur()/2,
      rayon = epais/2f; // rayon du cercle central
    // Active l'anti-crnelage
    RenderingHints hints =
      new RenderingHints(RenderingHints.KEY_ANTIALIASING,
			 RenderingHints.VALUE_ANTIALIAS_ON);
    g2.setRenderingHints(hints);
    // Les cercles concentriques
    Shape[] cercles = new Shape[max];
    for (int i=0; i<max; i++) {
      cercles[i] = new Ellipse2D.Float(cx-rayon,cy-rayon, rayon*2, rayon*2);
      rayon+=epais;
    }
    // Fixe l'paisseur du trait
    g2.setStroke(new BasicStroke(epais));
    // Trac du centre de la cible en rouge
    g2.setPaint(Color.red);
    g2.draw(cercles[0]);
    // Trac du reste de la cible alternativement en noir et en blanc
    for (int i=1; i<max; i++) {
      g2.setPaint(i%2 == 0 ? Color.white : Color.black);
      g2.draw(cercles[i]);
    }
  }

  // test for Ex1 

  public static void main(String[] args)
  {
    FenetreGraphique fen4 = new Ex1(150,335,Color.green);
    FenetreGraphique fen3 = new Ex1(100,300,Color.blue);
    FenetreGraphique fen2 = new Ex1(200,200,Color.yellow);
    FenetreGraphique fen = new Ex1();

    fen.ouvrir();
    fen2.ouvrir();
    fen3.ouvrir();
    fen4.ouvrir();
    
    fen.informer("fen");
    fen2.informer("fen2");
    fen3.informer("fen3");
    fen4.informer("fen4");
  }
}

