package graphiquetest; 
import java.awt.geom.*;
import java.awt.*;
import graphique.FenetreGraphique;

class Point {
  int x,y;
  
  Point() {};
  Point(int xi,int yi) { x=xi; y=yi; }
  Point(Point P) { x = P.x; y = P.y;} 

  public Point  alea(int max) 
  {
    x = (int)(max* Math.random());
    y = (int)(max* Math.random());
    return this;
  }

  public Point  trans(Point d)
  {
    x += d.x ;
    y += d.y ;
    return this;
  }
  
  public Point turn(double alpha)
  {
    double sina = Math.sin(alpha);
    double cosa = Math.cos(alpha);
    x = (int) (sina*x - cosa*x);
    x = (int) (cosa*x + sina*x);
    return this;
  }
}

class Polygon {
  Point[] sommets ;
  
  Polygon(int n, int max)
  {
    sommets = new Point[n];
    for (int i=0; i < sommets.length; i++) 
      sommets[i]= new Point().alea(max);
  }
  
  public void fillWithSin()
  {
    for (int i=0; i < sommets.length; i++) 
    
      {
	sommets[i].x = 10*i;
	sommets[i].y = (int) (100 * Math.sin(i)) + 100;
      }
  }

  public void fillWithAlea(int min,int max) 
  {
    for (int i=0; i < sommets.length; i++) 
      sommets[i].alea(max);
  }

}
  


class Ex3 extends FenetreGraphique 
{
  Polygon P;

  Ex3 () {} 
  Ex3 (int w, int h, Color c, Polygon P1) {
    super(w,h,c);
    P  = P1;
  }

  public void dessiner(Graphics2D g2)
  {
    int  epais = 2;    // paisseur du trait
    // Active l'anti-crnelage
    RenderingHints hints =
      new RenderingHints(RenderingHints.KEY_ANTIALIASING,
			 RenderingHints.VALUE_ANTIALIAS_ON);
    g2.setRenderingHints(hints);
    // Les cercles concentriques
    // Fixe l'paisseur du trait
    g2.setStroke(new BasicStroke(epais));
    GeneralPath path = new GeneralPath(GeneralPath.WIND_EVEN_ODD);
    path.moveTo(P.sommets[0].x, P.sommets[0].y);
    for (int i= 1 ; i < P.sommets.length ; i++) {
      path.lineTo(P.sommets[i].x, P.sommets[i].y);
    }
    g2.setPaint(Color.black);
    g2.draw(path);
  }

  public static void main(String[] args)
  {
    int w = args.length > 0 ? Integer.parseInt(args[0]) : 300;
    int h = args.length > 1 ? Integer.parseInt(args[1]) : 300;
    Polygon P = new Polygon(20,w);
    P.fillWithSin();
    Ex3 fen = new Ex3(w,h,Color.white,P);
    fen.ouvrir();
    fen.informer("fen");
  }
}










