package graphiquetest; 
import java.awt.geom.*;
import java.awt.*;
import graphique.FenetreGraphique;

class Point {
  protected float x,y; 

  public Point(float x,float y) {
    this.x = x; 
    this.y = y;
  }

  public float getX() {
    return x;
  }

  public float getY() {
    return y;
  }
  void translater(float dx, float dy) {
    x = x+dx;
    y = y+dy;
  }

  void translater(float d) {
    translater(d,d);
  }
}

class Cercle {

  protected float rayon;
  protected Shape c; 
  protected Point centre; 

  Cercle(Point centre, float rayon) {
    this.centre = centre;
    this.rayon = rayon ;
    c = new Ellipse2D.Float(centre.getX()-rayon,centre.getY()+rayon,
			    2*rayon,2*rayon);
  }

  Shape getShape() { return c;}

  void translater(float dx,float dy) {
    centre.translater(dx,dy); 
    c = new Ellipse2D.Float(centre.getX()-rayon,centre.getY()+rayon,
			    2*rayon,2*rayon);
  }
}

class Exemple extends FenetreGraphique 
{
  Exemple () {}
  Exemple (int w, int h, Color c) {
    super(w,h,c);
  }

  public void dessiner(Graphics2D g2)
  {
    int  epais = 1;    // paisseur du trait
    float L= getLargeur(), H = getHauteur(); 
    Cercle c = new Cercle(new Point(L/2,H/2),H/10); 
    g2.setStroke(new BasicStroke(epais));
    // Active l'anti-crnelage
    RenderingHints hints =
      new RenderingHints(RenderingHints.KEY_ANTIALIASING,
			 RenderingHints.VALUE_ANTIALIAS_ON);
    g2.setRenderingHints(hints);
    for (int i=0; i < 10 ; i++) {
      g2.setPaint(Color.green);
      g2.fill( c.getShape());
      g2.setPaint(Color.red);
      g2.draw( c.getShape());
      c.translater(10,10);
    }
  }

  // test for Ex1 

  public static void main(String[] args)
  {
    FenetreGraphique fen1 = new Exemple(100,300,Color.blue);
    fen1.ouvrir();
    fen1.informer("exemple de graphique");
  }
}


