// Rajout d'une image  + reduction de l'image 
// pour diaporama 
//-----------------------------------------------------------

import java.sql.*;
import java.util.*;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;

class Fenetre extends Frame 
  implements MouseListener,ActionListener, WindowListener {

  //Composants de GUI
  MenuBar menus;
  Menu fichiers;
  MenuItem quitter;
  MenuItem test ;
  ImageButton poo;
  SizedPanel pdiapos; // Panel pour Diaporama 
  SizedScrollPane  sdiapos; // fait scroller pdiapos
  Label label;       //  Messages 

  // Acces a la base 
  Connection con;
  ResultSet rs;
  MediaTracker tracker;
  
  Fenetre(String titre) {
    super(titre);
    int w,h,wim=50,him=50, ni=0;  // 

    setFont(new Font("SansSerif", Font.ITALIC, 12));
    addWindowListener(this);

    // Le menu 
    menus = new MenuBar();
    fichiers = new Menu("Fichier");
    quitter = new MenuItem("Quitter");
    test = new MenuItem("Test");
    fichiers.add(quitter);
    fichiers.add(test);
    menus.add(fichiers);
    setMenuBar(menus);
    quitter.addActionListener(this);
    test.addActionListener(this);

    // Message 
    label = new Label("-------");
    label.setBackground(new Color(255,255,0));

    // Panels 
    sdiapos = new SizedScrollPane();
    pdiapos = new SizedPanel();
    sdiapos.add(pdiapos);

    // Mise en place dans le BorderLayout de la fenetre 
    add("South",  label);
    add("Center", sdiapos);

    // Chargement des images dans le diaporama 
    tracker = new MediaTracker(this);
    try {
      Images();
      while(rs.next()) {
	ni++;
	String str1 = rs.getString("filename");
	pdiapos.add(poo=get_image(str1,wim,him,tracker));
      }
    }
    catch( Exception e ) {
      e.printStackTrace();
      label.setText("Oooops .... No data base connection No names");
    }

    // Resize du panel contenant le  Diaporama. 
    FlowLayout fl = (FlowLayout)pdiapos.getLayout();
    int he = fl.getHgap();
    int ve = fl.getVgap();
    w=h=(int)Math.ceil(Math.sqrt((wim+he)*(him+ve)*ni));
    pdiapos.w = w;
    pdiapos.h = h;

  }

  void afficher() {
    pack();
    show();
  }
  
  void quitter() {
    dispose();
    System.exit(0);
  }

  public void actionPerformed(ActionEvent event) {
    if (event.getSource() == quitter ) {
      quitter();
    } 
    else if (event.getSource() == test ) {
      // poo.repaint();
      // pdiapos.getGraphics());
    }
    else {}
  }


  public void windowClosing(WindowEvent e) {
    try {
      con.close();
    } catch (SQLException ex) {
      ex.printStackTrace();
    }
    quitter();
  }

  public void mouseClicked(MouseEvent e){};
  public void mouseEntered(MouseEvent e){};
  public void mouseExited(MouseEvent e){};
  public void mousePressed(MouseEvent e){};
  public void mouseReleased(MouseEvent e){
    ImageButton b =(ImageButton) e.getSource();
    // b.paint(b.getGraphics());
    b.repaint();
    label.setText("Source : " + b.toString());
  };

  public void windowOpened(WindowEvent e) {}
  public void windowClosed(WindowEvent e) {}
  public void windowIconified(WindowEvent e) {}
  public void windowDeiconified(WindowEvent e) {}
  public void windowActivated(WindowEvent e) {}
  public void windowDeactivated(WindowEvent e) {}

  // Connexion a la base, selection des images et remplissage du champ 
  // rs de la fenetre (ResultSet).

  public void Images() throws ClassNotFoundException,SQLException
    {
      String url = "jdbc:msql://deedee.enpc.fr:1114/mulot";
      Statement stmt;
      Class.forName("com.imaginary.sql.msql.MsqlDriver");
      con = DriverManager.getConnection(url, "mulot", "");
      stmt = con.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,
				 ResultSet.CONCUR_READ_ONLY);
      rs = stmt.executeQuery("SELECT filename from test1");
    }
  
  // Charge une image de nom de fichier name, 
  // retaille (w,h) l'image et la met dans un ImageCanvas qui est 
  // retourne
  
  public ImageButton get_image(String name,int w,int h, MediaTracker tracker) 
    {
      String base_name= name.substring(0,name.lastIndexOf(".grey"));
      ImageButton c = null;
      try {
	Image iloc;
	iloc = Toolkit.getDefaultToolkit().getImage("/u/cergrene/0/jpc/Java/BD-voyageur/"+base_name+".jpg");
	ImageProducer source = iloc.getSource();
	ReplicateScaleFilter filtre = new ReplicateScaleFilter(w,h) ;
	ImageProducer ip = new FilteredImageSource(source, filtre);
	c = new ImageButton(tracker,w,h);
	c.i = createImage(ip);
	tracker.addImage(c.i, 0);
	tracker.waitForID(0);
	c.addMouseListener(this);
      }
      catch (Exception e) {
	e.printStackTrace();
	label.setText("Oooops .... Pb dans le chargement de l'image");
      }
      return c;
  }
}

// Canvas avec tracker specifie et dessin si l'image existe 
// et est chargee

class ImageCanvas extends Canvas {
  MediaTracker tracker;
  Image i;

  ImageCanvas(MediaTracker tracker,int w, int h) {
    this.tracker = tracker;
    setSize(w,h);
  }

  public void paint(Graphics g) {
    if ( i != null && tracker.checkID(0)) {
      g.drawImage(i,0,0,null);
    }
  }
}

// Bouton avec tracker specifie et dessin si l'image existe 
// et est chargee ( un bouton avec image dedans ) 

class ImageButton extends Button {
  MediaTracker tracker;
  Image i;
  int w,h;

  ImageButton(MediaTracker tracker,int w, int h) {
    this.tracker = tracker;    
    this.w = w;
    this.h = h;
  }

  public Dimension getPreferredSize() 
    {
      return new Dimension(w,h);
    }

  public void paint(Graphics g) {
    super.paint(g);
    if ( i != null && tracker.checkID(0)) {
      g.drawImage(i,0,0,null);
    }
    getParent().repaint();
  }


}


// Panneaux dont la dimension a la creation est fixee par nous

class SizedPanel extends Panel {
  int w,h;

  public Dimension getPreferredSize() 
    {
      return new Dimension(w,h);
    }
}

class SizedScrollPane extends ScrollPane {
  public Dimension getPreferredSize() 
    {
      return new Dimension(300,300);
    }
}

// Le programme principal : affiche la fenetre 

class Diapo {
  public static void main(String[] args) {
    Fenetre fenetre = new Fenetre("Diaporama");
    fenetre.setLocation(30,30);
    fenetre.afficher();
  }
}

